#include "ActionList.h"
#include <cassert>

ActionList::ActionList()
	:
	max_rect(0,0,0,0)
{}

ActionList::ActionList(int l, int r, int t, int b)
	:
	max_rect(l, r, t, b)
{}

void ActionList::add_button(std::string t, Color c, Action a)
{
	assert(t.size() * 16 <= (max_rect.right - max_rect.left));
	int y = button.size() * 35 + max_rect.top;
	ActionButton b(max_rect.left, max_rect.left + t.size() * 16, y, y + 28, t, c, a);
	button.push_back(b);
}

void ActionList::remove_button(int i)
{
	if (i == (button.size() - 1))
		button.pop_back();
	else
	{
		int count = 0;
		for (auto& b : button)
		{
			if (count > i)
			{
				b.decrease_height(35);
			}
			count++;
		}
		button.erase(button.begin() + i);
	}
}

void ActionList::remove_button(std::string t)
{
	int count = 0;
	for (auto& b : button)
	{
		if (b.action.type == t)
		{
			remove_button(count);
		}
		count++;
	}
}

void ActionList::print(Graphics& gfx, Font& f)
{
	for (auto& i : button)
	{
		if (i.get_bottom() <= max_rect.bottom)
			i.draw(gfx, f);
	}
}