#include "Button.h"
#include "Constants.h"

Button::Button()
	:
	area(0,0,0,0),
	text(" ")
{
	colour = Colors::Black;
}

Button::Button(int left, int right, int top, int bottom, std::string s, Color c)
	:
	area(left,right,top,bottom),
	text(s),
	colour(c)
{}

void Button::draw(Graphics& gfx, Font& f)
{
	f.drawText(text, { area.left,area.top }, gfx, colour);
}

bool Button::is_clicked(Mouse& m)
{
	return (m.LeftIsPressed() && m.GetPosX() >= area.left && m.GetPosX() <= area.right && m.GetPosY() >= area.top && m.GetPosY() <= area.bottom);
}

void Button::draw_outline(Graphics& gfx)
{
	for (int i = area.left; i < area.right; i++)
	{
		gfx.PutPixel(i, area.top, Colors::White);
		gfx.PutPixel(i, area.bottom, Colors::White);
	}
	for (int i = area.top; i < area.bottom; i++)
	{
		gfx.PutPixel(area.left, i, Colors::White);
		gfx.PutPixel(area.right, i, Colors::White);
	}
}

int Button::get_bottom()
{
	return area.bottom;
}

void Button::decrease_height(int decr)
{
	area.top -= decr;
	area.bottom -= decr;
}

std::string Button::get_text()
{
	return text;
}