#include "Galaxy.h"
#include "Planet.h"

Galaxy::Galaxy(std::mt19937& rng)
{
	std::uniform_int_distribution<int> dstar(1, 20);
	std::uniform_int_distribution<int> dplanet(1, 6);
	std::uniform_int_distribution<int> dhabitable(1, 2);
	std::uniform_int_distribution<int> dasteroid(1, 4);
	std::uniform_int_distribution<int> d3(1, 3);
	int roll;
	int roll2;
	for (int i = 0; i < GALAXY_SIZE; i++)
	{
		sector[i].loc.x = i % GALAXY_WIDTH;
		sector[i].loc.y = i / GALAXY_WIDTH;
		roll = dstar(rng);
		if (roll == 1)
		{
			sector[i].star = true;
		}
		else
		{
			sector[i].star = false;
		}
	}
	for (int i = 0; i < GALAXY_SIZE; i++)
	{
		roll = dplanet(rng);
		roll2 = dasteroid(rng);
		if (roll == 1 && sector[i].star == false)
		{
			if (i == 0)
			{
				if (sector[1].star == true || sector[GALAXY_WIDTH].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
			else if (i == GALAXY_WIDTH-1)
			{
				if (sector[GALAXY_WIDTH - 2].star == true || sector[2 * GALAXY_WIDTH - 1].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
			else if (i == GALAXY_SIZE-GALAXY_WIDTH)
			{
				if (sector[GALAXY_SIZE - GALAXY_WIDTH + 1].star == true || sector[GALAXY_SIZE - 2 * GALAXY_WIDTH].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
			else if (i == GALAXY_SIZE-1)
			{
				if (sector[GALAXY_SIZE - 2].star == true || sector[GALAXY_SIZE - GALAXY_WIDTH - 1].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
			else if (i / GALAXY_WIDTH == 0)
			{
				if (sector[i - 1].star == true || sector[i + 1].star == true || sector[i + GALAXY_WIDTH].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
			else if (i / GALAXY_WIDTH == GALAXY_HEIGHT-1)
			{
				if (sector[i - 1].star == true || sector[i + 1].star == true || sector[i - GALAXY_WIDTH].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
			else if (i % GALAXY_WIDTH == 0)
			{
				if (sector[i - GALAXY_WIDTH].star == true || sector[i + 1].star == true || sector[i + GALAXY_WIDTH].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
			else if (i % GALAXY_WIDTH == GALAXY_WIDTH-1)
			{
				if (sector[i - 1].star == true || sector[i - GALAXY_WIDTH].star == true || sector[i + GALAXY_WIDTH].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
			else
			{
				if (sector[i - 1].star == true || sector[i + 1].star == true || sector[i + GALAXY_WIDTH].star == true || sector[i - GALAXY_WIDTH].star == true)
				{
					Planet newplanet(sector[i].loc, rng);
					sector[i].planet.push_back(newplanet);
				}
			}
		}
		else if (roll2 == 1 && sector[i].star == false)
		{
			if (i == 0)
			{
				if (sector[1].star == true || sector[GALAXY_WIDTH].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
			else if (i == GALAXY_WIDTH - 1)
			{
				if (sector[GALAXY_WIDTH - 2].star == true || sector[2 * GALAXY_WIDTH - 1].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
			else if (i == GALAXY_SIZE - GALAXY_WIDTH)
			{
				if (sector[GALAXY_SIZE - GALAXY_WIDTH + 1].star == true || sector[GALAXY_SIZE - 2 * GALAXY_WIDTH].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
			else if (i == GALAXY_SIZE - 1)
			{
				if (sector[GALAXY_SIZE - 2].star == true || sector[GALAXY_SIZE - GALAXY_WIDTH - 1].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
			else if (i / GALAXY_WIDTH == 0)
			{
				if (sector[i - 1].star == true || sector[i + 1].star == true || sector[i + GALAXY_WIDTH].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
			else if (i / GALAXY_WIDTH == GALAXY_HEIGHT - 1)
			{
				if (sector[i - 1].star == true || sector[i + 1].star == true || sector[i - GALAXY_WIDTH].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
			else if (i % GALAXY_WIDTH == 0)
			{
				if (sector[i - GALAXY_WIDTH].star == true || sector[i + 1].star == true || sector[i + GALAXY_WIDTH].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
			else if (i % GALAXY_WIDTH == GALAXY_WIDTH - 1)
			{
				if (sector[i - 1].star == true || sector[i - GALAXY_WIDTH].star == true || sector[i + GALAXY_WIDTH].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
			else
			{
				if (sector[i - 1].star == true || sector[i + 1].star == true || sector[i + GALAXY_WIDTH].star == true || sector[i - GALAXY_WIDTH].star == true)
				{
					roll2 = d3(rng);
					if (roll2 == 1)
					{
						sector[i].asteroid.push_back('D');
					}
					if (roll2 == 2)
					{
						sector[i].asteroid.push_back('A');
					}
					if (roll2 == 3)
					{
						sector[i].asteroid.push_back('U');
					}
				}
			}
		}
	}
}

Sector Galaxy::get_sector(int i)
{
	return sector[i];
}

void Galaxy::set_planet_colour(int i, Color c)
{
	sector[i].planet[0].set_colour(c);
}

void Galaxy::set_ship_colour(int i, Color c)
{
	sector[i].ship[0].set_colour(c);
}

void Galaxy::place_ship(int i, Color c)
{
	Ship s({ i % GALAXY_WIDTH,i / GALAXY_WIDTH }, c);
	sector[i].ship.push_back(s);
}

/*
void Galaxy::print(Graphics& gfx,Font& f,Player& p)
{
	Location loc = { 0,0 };
	for (int i = 0; i < GALAXY_SIZE; i++)
	{
		loc.x = (i % GALAXY_WIDTH) * SECTOR_DIMENSION;
		loc.y = (i / GALAXY_WIDTH) * SECTOR_DIMENSION;
		if (sector[i].star == true)
		{
			gfx.DrawRectDim(loc.x, loc.y, SECTOR_DIMENSION, SECTOR_DIMENSION, Colors::White);
		}
		else if (p.is_discovered(i) == true)
		{
			if (!sector[i].planet.empty())
			{
				gfx.DrawRectDim(loc.x, loc.y, SECTOR_DIMENSION, SECTOR_DIMENSION, sector[i].planet[0].get_colour());
			}
			else
			{
				if (p.is_in_range(i) == true)
				{
					gfx.DrawRectDim(loc.x, loc.y, SECTOR_DIMENSION, SECTOR_DIMENSION, Colors::LightGray);
				}
				else
				{
					gfx.DrawRectDim(loc.x, loc.y, SECTOR_DIMENSION, SECTOR_DIMENSION, Colors::Gray);
				}
			}
			if (!sector[i].asteroid.empty())
			{
				char c = sector[i].asteroid[0];
				Color col;
				if (c == 'U')
					col = Colors::Green;
				if (c == 'D')
					col = Colors::MakeRGB(128u, 0u, 128u);
				if (c == 'A')
					col = Colors::Yellow;
				std::string s(1, c);
				f.drawText(s, { loc.x + 17, loc.y + 11 }, gfx, col);
			}
			if (p.is_in_range(i) && !sector[i].ship.empty())
			{
				std::string shipstring = "S";
				f.drawText(shipstring, { loc.x + 17,loc.y + 11 }, gfx, sector[i].ship[0].get_colour());
			}
			if (p.is_in_range(i) && !sector[i].space_station.empty())
			{
				std::string stationstring = "SS";
				f.drawText(stationstring, { loc.x + 9,loc.y + 11 }, gfx, sector[i].space_station[0].get_colour());
			}
		}
	}

	for (int i = 0; i < GALAXY_HEIGHT; i++)
	{
		gfx.PutPixel(GALAXY_WIDTH * SECTOR_DIMENSION, i, Colors::White);
	}
}*/