#pragma once
#include "Location.h" 
#include <random>
#include "Planet.h"
#include "Constants.h"
#include "Ship.h"
//#include "Player.h"
#include "SpaceStation.h"

struct Sector
{
	Sector()
	{
		loc = EMPTY;
		star = false;
	}
	Location loc;
	bool star;
	std::vector<SpaceStation> space_station;
	std::vector<Planet> planet;
	std::vector<Ship> ship;
	std::vector<char> asteroid;  //U-uranium A-antimatter D-dark matter
};

class Galaxy
{
public:
	Galaxy(std::mt19937& rng);
	Sector get_sector(int i);
	void set_planet_colour(int i, Color c);
	void set_ship_colour(int i, Color c);
	void place_ship(int i, Color c);
	//void print(Graphics& gfx,Font& f,Player& p);
private:
	Sector sector[GALAXY_SIZE];
};
