/****************************************************************************************** 
 *	Chili DirectX Framework Version 16.07.20											  *	
 *	Game.h																				  *
 *	Copyright 2016 PlanetChili.net <http://www.planetchili.net>							  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#pragma once

#include "Keyboard.h"
#include "Mouse.h"
#include "Graphics.h"
#include "Galaxy.h"
#include "Player.h"
#include "Font.h"
#include <random>
#include "LocationList.h"
#include "Button.h"
#include "ProjectList.h"

class Game
{
public:
	Game(class MainWindow& wind);
	Game(const Game&) = delete;
	Game& operator=(const Game&) = delete;
	void Go();
private:
	void startTurn(int p);
	void drawGalaxy(int p);
	void gameScreen(int p);
	void setUpScreen(int p);
	void load(int p);
	bool is_beside_colony(Ship& s);
	/********************************/
	/*  User Functions              */
	/********************************/
private:
	MainWindow& wnd;
	Graphics gfx;
	/********************************/
	/*  User Variables              */
	/********************************/
	std::mt19937 rng;
	Galaxy galaxy;
	Player player[NUMPLAYERS];
	Font font;
	int playernum = 0;
	Planet print_planet{};
	Location list_loc = EMPTY;
	int place_loc = -1;
	Action current_action;
	bool do_action = false;
	bool start_screen = true;
	bool loaded = false;
	bool view_planet_list = false;
	bool view_ship_list = false;
	bool view_tech = false;
	bool view_action_list = false;
	char job = ' ';
	int person_num = 0;
	Project project;
	LocationList colonies;
	LocationList ships;
	ProjectList proj_list;
};