#include "LocationList.h"
#include <cassert>

LocationList::LocationList(int l, int r, int t, int b)
	:
	max_rect(l, r, t, b)
{}

void LocationList::add_button(std::string t, Color c, Location l)
{
	assert(t.size() * 16 <= (max_rect.right - max_rect.left));
	int y = button.size() * 35 + max_rect.top;
	LocationButton b(max_rect.left, max_rect.left + t.size() * 16, y, y + 28, t, c, l);
	button.push_back(b);
}

void LocationList::remove_button(int i)
{
	if (i == (button.size() - 1))
		button.pop_back();
	else
	{
		int count = 0;
		for (auto& b : button)
		{
			if (count > i)
			{
				b.decrease_height(35);
			}
			count++;
		}
		button.erase(button.begin() + i);
	}
}

void LocationList::print(Graphics& gfx, Font& f)
{
	for (auto& i : button)
	{
		if (i.get_bottom() <= max_rect.bottom)
			i.draw(gfx, f);
	}
}

void LocationList::clear()
{
	while (!button.empty())
		button.pop_back();
}