#include "ProjectList.h"
#include <cassert>

ProjectList::ProjectList(int l, int r, int t, int b)
	:
	max_rect(l,r,t,b)
{}

void ProjectList::add_button(std::string t, Color c, Project p)
{
	assert(t.size() <= (max_rect.right - max_rect.left));
	int y = button.size() * 35 + max_rect.top;
	ProjectButton b(max_rect.left, max_rect.left + t.size() * 16, y, y + 28, t, c, p);
	button.push_back(b);
}

void ProjectList::print(Graphics& gfx, Font& f)
{
	for (auto& i : button)
	{
		if (i.get_bottom() <= max_rect.bottom)
		{
			i.draw(gfx, f);
			i.draw_outline(gfx);
		}
	}
}

void ProjectList::clear()
{
	while (!button.empty())
		button.pop_back();
}