#include "Ship.h"
#include "Constants.h"
#include <cassert>
#include "Colors.h"

Ship::Ship()
	:
	loc(EMPTY),
	action_list(1250, 1500, 70, 750)
{
	colour = Colors::Black;
}

Ship::Ship(Location location, Color c)
	:
	loc(location),
	colour(c),
	action_list(1250,1500,70,750)
{}

int Ship::get_engineering()
{
	int engineering = 0;
	for (auto& i:person)
	{
		if (i.job == 'e')
			engineering += i.ability;
	}
	return engineering;
}

int Ship::get_invasion_pts()
{
	int invasion_pts = 0;
	for (auto& i : person)
	{
		if (i.job == 's')
			invasion_pts += i.ability;
	}
	return invasion_pts;
}

int Ship::get_population()
{
	int population = 0;
	for (auto& i : person)
		population++;
	return population;
}

Location Ship::get_loc()
{
	return loc;
}

int Ship::get_health()
{
	return health;
}

int Ship::get_moves()
{
	return moves;
}

int Ship::get_food()
{
	return food;
}

int Ship::get_uranium()
{
	return uranium;
}

int Ship::get_antimatter()
{
	return antimatter;
}

int Ship::get_darkmatter()
{
	return dark_matter;
}

int Ship::get_antimatter_bombs()
{
	return antimatter_bombs;
}

int Ship::get_nuclear_missiles()
{
	return nuclear_missiles;
}

int Ship::get_warp_engines()
{
	return warp_engines;
}


void Ship::set_loc(Location l)
{
	loc = l;
}

void Ship::add_action(std::string t,bool n, int num)
{
	Action a(t,n,num);
	action.push_back(a);
	Color c = Colors::White;
	if (n == true)
		c = Colors::Red;
	action_list.add_button(t, c,a);
}

void Ship::remove_action(int i)
{
	assert(i != 0);
	assert(i < action.size());
	if (i == (action.size() - 1))
	{
		action.pop_back();
	}
	if (i < (action.size() - 1))
	{
		action.erase(action.begin() + i);
	}
}

Color Ship::get_colour()
{
	return colour;
}

void Ship::update_food()
{
	food -= get_population();
	if (food < 0)
		add_action("Starvation", true, abs(food));
}

bool Ship::is_empty()
{
	return (food == 0 && uranium == 0 && antimatter == 0 && dark_matter == 0 && antimatter_bombs == 0 && nuclear_missiles == 0 && warp_engines == 0 && get_population() == 0);
}

void Ship::set_colour(Color c)
{
	colour = c;
}