#pragma once
#include "Person.h"
#include "Location.h"
#include "Action.h"
#include <vector>
#include "Colors.h"
#include "ActionList.h"

class Ship
{
public:
	Ship();
	Ship(Location location, Color c);
	int get_engineering();
	int get_invasion_pts();
	int get_population();
	Location get_loc();
	int get_health();
	int get_moves();
	int get_food();
	int get_uranium();
	int get_antimatter();
	int get_darkmatter();
	int get_antimatter_bombs();
	int get_nuclear_missiles();
	int get_warp_engines();
	void set_loc(Location l);
	void add_action(std::string t,bool n,int num);
	void remove_action(int i);
	Color get_colour();
	void update_food();
	bool is_empty();
	void set_colour(Color c);
private:
	Location loc;
	Color colour;
	int health=50;
	int moves=0;
	int food=0;
	int uranium=0;
	int antimatter=0;
	int dark_matter=0;
	int antimatter_bombs=0;
	int nuclear_missiles=0;
	int warp_engines=0;
public:
	std::vector<Person> person;
	std::vector<Action> action;
	ActionList action_list;
};